#include "Enemy.h"
#include "Shot.h"
#include "Player.h"
#include "Item.h"

#define SQUARE( num ) ((num)*(num))

namespace Collision {
	void EnemyPlayer( Enemy& enemy ){
		if( !enemy.IsExist() ){
			return;
		}
		double enemyX, enemyY;
		double playerX, playerY;

		enemy.GetPos( enemyX, enemyY );
		Player::GetPos( playerX, playerY );
		int enemyRadius = enemy.GetRadius();
		int playerRadius = Player::GetRadius();
		
		if ( SQUARE( enemyX - playerX ) + SQUARE( enemyY - playerY ) < SQUARE( enemyRadius + playerRadius ) ) {
			Player::Hit();
		}
	}
	void EnemyPlayer( void ){
		auto enemyList = Enemy::GetEnemyList();
		for( auto enemy = enemyList.begin(); enemy != enemyList.end(); ++enemy ){
			EnemyPlayer( *( *enemy ) );
		}
	}
	void EnemyShot( Enemy& enemy, Shot& shot ){
		if( !enemy.IsExist() ){
			return;
		}
		if( !shot.IsExist() ){
			return;
		}
		if( enemy.GetType() == Enemy::BULLET ){
			return;
		}

		double enemyX, enemyY;
		double shotX, shotY;

		enemy.GetPos( enemyX, enemyY );
		shot.GetPos( shotX, shotY );
		int enemyRadius = enemy.GetRadius();
		int shotRadius = Shot::RADIUS;

		if ( SQUARE( enemyX - shotX ) + SQUARE( enemyY - shotY ) < SQUARE( shotRadius + enemyRadius ) ) {
			if( enemy.GetType() == Enemy::EXPAND ){
				enemy.HitExpand( shot );
			}
			shot.Hit();
			enemy.Hit();
		}
	}
	void EnemyShot( void ){
		auto enemyList = Enemy::GetEnemyList();
		auto shotList = Shot::GetShotList();
		for ( auto enemy = enemyList.begin(); enemy != enemyList.end(); ++enemy ) {
			for( auto shot = shotList.begin(); shot != shotList.end(); ++shot ){
				EnemyShot( *( *enemy ), *( *shot ) );
			}
		}
	}
	void ItemPlayer( Item& item ){
		if( !item.IsExist() ){
			return;
		}
		double playerX, playerY;
		double itemX, itemY;

		item.GetPos( itemX, itemY );
		Player::GetPos( playerX, playerY );

		int playerRadius = Player::GetRadius();
		int itemRadius = item.GetRadius();

		if( SQUARE( itemX - playerX ) + SQUARE( itemY - playerY ) < SQUARE( playerRadius + itemRadius ) ){
			Player::ShotPowerUp();
			item.SetExistFalse();
		}
	}
	void ItemPlayer( void ){
		auto itemList = Item::GetItemList();
		for( auto item = itemList.begin(); item != itemList.end(); ++item ){
			ItemPlayer( ( *( *item ) ) );
		}
	}
};