#include "Effect.h"

Effect::Img Effect::_img;
std::list< Effect* > Effect::_effectList;

Effect::Effect( double x, double y, double exRate ){
	_x = x;
	_y = y;
	_exRate = exRate;
	_count = 0;
	_exist = true;
	_effectList.push_back( this );
}

int Effect::Draw( void ){
	SetDrawBlendMode( DX_BLENDMODE_ADD, 255 );
	DrawRotaGraph( static_cast< int >( _x ), static_cast< int >( _y ), _exRate, 0.0, _img._explode[ ( _count * 29 ) / EXPLODE_ANIM_LENGTH ], TRUE );
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
	_count++;
	if( _count == EXPLODE_ANIM_LENGTH ){
		_exist = false;
	}
	return 0;
}

int Effect::DrawAll( void ){
	for( auto it = _effectList.begin(); it != _effectList.end(); ){
		if( ( *it )->_exist == true ){
			( *it )->Draw();
			if( ( *it )->_exist == false ){
				delete ( *it );
				it = _effectList.erase( it );
				continue;
			}
		}
		++it;
	}
	return 0;
}

int Effect::LoadImg( void ){
	LoadDivGraph( "img\\explode.png", 29, 8, 4, 80, 80, _img._explode );
	return 0;
}