#ifndef INPUT_H
#define INPUT_H

class Input
{
public:
	Input();
	void Update( void );
	static int GetAnalog( int num )
	{
		return _p->_analog[ num ];
	}
	static int GetButton( int num ){
		return _p->_button[ num ];
	}
	void LoadConfig( void );
	void LoadDefaultConfig( void );
	void SaveDefaultConfig( void );
private:
	DINPUT_JOYSTATE _dInputJoystate;
	static const int ANALOG_MAX = 4;
	static const int BUTTON_MAX = 1;
	int _analog[ ANALOG_MAX ];
	int _button[ BUTTON_MAX ];

	char _key[ 256 ];

	static Input* _p;

	struct{
		int _attackUp;				// U
		int _attackDown;			// U
		int _attackLeft;			// U
		int _attackRight;			// EU
		int _pause;					// |[Y
		int _attackAnalog[ 2 ];		// AiOXeBbÑ^Cv
		bool _useDirectInputFlag;	// DirectInputgp邩ۂ
	}_config;
};

#endif