#include "Item.h"
#include "DxLib.h"

const double Item::PROBABILITY( 0.2 );
const double Item::VELOCITY( 1.0 );

std::list< Item* > Item::_itemList;
int Item::_img;

Item::Item( double x, double y, double vx, double vy ){
	_x = x;
	_y = y;
	_vx = vx;
	_vy = vy;
	_exist = true;
	_itemList.push_back( this );
}
void Item::Move( void ){
	_x += _vx;
	_y += _vy;
	if( _x <= -100 || 740 <= _x || _y <= -100 || 580 <= _y ){
		_exist = false;
	}
}
int Item::Draw( void ){
	int rv = 0;
	rv |= DrawGraph( static_cast< int >( _x ) - 24, static_cast< int >( _y ) - 24, _img, TRUE );
#ifdef _DEBUG
	rv |= DrawCircle( static_cast< int >( _x ), static_cast< int >( _y ), 16, GetColor( 255, 255, 0 ), false );
#endif
	return rv;
}
int Item::DrawAll( void ){
	for( auto it = _itemList.begin(); it != _itemList.end(); ){
		if( ( *it )->_exist ){
			( *it )->Draw();
		}
		if( !( *it )->_exist ){
			delete ( *it );
			it = _itemList.erase( it );
			continue;
		}
		++it;
	}
	return 0;
}
void Item::MoveAll( void ){
	for( auto it = _itemList.begin(); it != _itemList.end(); ){
		if( ( *it )->_exist ){
			( *it )->Move();
		}
		if( !( *it )->_exist ){
			delete ( *it );
			it = _itemList.erase( it );
			continue;
		}
		++it;
	}
}
void Item::EraseAll( void ){
	for( auto it = _itemList.begin(); it != _itemList.end(); ){
		delete ( *it );
		it = _itemList.erase( it );
		continue;
	}
}
int Item::LoadImg( void ){
	_img = LoadGraph( "img\\shot_power.png" );
	return 0;
}