#ifndef LEVEL_H
#define LEVEL_H

#include <sstream>
#include "Enemy.h"
#include "DxLib.h"
#include <math.h>

class Level {
private:
	static Level* _p;
public:
	static const int LEVEL_MAX = 25;
	Level(){
		_level = 1;
		_count = 0;
		_p = this;
	}
	void Run(){
		if( _count == LEVEL_DISP_COUNT ){
			switch( _level % LEVEL_MAX ){
			case 1:
				{
					Enemy::Create( 240, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 400, Enemy::BASIC, Enemy::TOP );
					break;
				}
			case 2:
				{
					Enemy::Create( 160, Enemy::BASIC, Enemy::BOTTOM );
					Enemy::Create( 320, Enemy::BASIC, Enemy::BOTTOM );
					Enemy::Create( 480, Enemy::BASIC, Enemy::BOTTOM );
					break;
				}
			case 3:
				{
					Enemy::Create( 240, Enemy::BASIC, Enemy::LEFT );
					Enemy::Create( 240, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 4:
				{
					Enemy::Create( 240, Enemy::EXPAND, Enemy::TOP );
					Enemy::Create( 400, Enemy::STAR, Enemy::TOP );
					break;
				}
			case 5:
				{
					Enemy::Create( 160, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 320, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 240, Enemy::SPIDER, Enemy::RIGHT );
					break;
				}
			case 6:
				{
					Enemy::Create( 240, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 400, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 240, Enemy::BASIC, Enemy::BOTTOM );
					Enemy::Create( 400, Enemy::BASIC, Enemy::BOTTOM );
					break;
				}
			case 7:
				{
					Enemy::Create( 320, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 240, Enemy::SPIDER, Enemy::LEFT );
					Enemy::Create( 240, Enemy::SPIDER, Enemy::RIGHT );
					break;
				}
			case 8:
				{
					Enemy::Create( 320, Enemy::STAR, Enemy::BOTTOM );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::RIGHT );
					break;
				}
			case 9:
				{
					Enemy::Create( 240, Enemy::GIANT, Enemy::LEFT );
					Enemy::Create( 160, Enemy::BASIC, Enemy::RIGHT );
					Enemy::Create( 320, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 10:
				{
					Enemy::Create( 320, Enemy::STAR, Enemy::TOP );
					Enemy::Create( 320, Enemy::STAR, Enemy::BOTTOM );
					break;
				}
			case 11:
				{
					Enemy::Create( 240, Enemy::SPIDER, Enemy::LEFT );
					Enemy::Create( 240, Enemy::SPIDER, Enemy::RIGHT );
					break;
				}
			case 12:
				{
					Enemy::Create( 240, Enemy::GIANT, Enemy::RIGHT );
					Enemy::Create( 160, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 320, Enemy::EXPAND, Enemy::LEFT );
					break;
				}
			case 13:
				{
					Enemy::Create( 320, Enemy::EXPAND, Enemy::TOP );
					Enemy::Create( 320, Enemy::EXPAND, Enemy::BOTTOM );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::RIGHT );
					break;
				}
			case 14:
				{
					Enemy::Create( 240, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 400, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::BOTTOM );
					Enemy::Create( 400, Enemy::EXPAND, Enemy::BOTTOM );
					break;
				}
			case 15:
				{
					Enemy::Create( 160, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 480, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 240, Enemy::STAR, Enemy::BOTTOM );
					break;
				}
			case 16:
				{
					Enemy::Create( 160, Enemy::STAR, Enemy::LEFT );
					Enemy::Create( 320, Enemy::STAR, Enemy::LEFT );
					Enemy::Create( 240, Enemy::GIANT, Enemy::RIGHT );
					break;
				}
			case 17:
				{
					Enemy::Create( 160, Enemy::BASIC, Enemy::LEFT );
					Enemy::Create( 320, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 160, Enemy::EXPAND, Enemy::RIGHT );
					Enemy::Create( 320, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 18:
				{
					Enemy::Create( 240, Enemy::STAR, Enemy::LEFT );
					Enemy::Create( 240, Enemy::STAR, Enemy::RIGHT );
					Enemy::Create( 320, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 320, Enemy::BASIC, Enemy::BOTTOM );
					break;
				}
			case 19:
				{
					Enemy::Create( 160, Enemy::EXPAND, Enemy::TOP );
					Enemy::Create( 320, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 480, Enemy::EXPAND, Enemy::TOP );
					Enemy::Create( 240, Enemy::BASIC, Enemy::LEFT );
					Enemy::Create( 240, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 20:
				{
					Enemy::Create( 160, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 480, Enemy::GIANT, Enemy::BOTTOM );
					Enemy::Create( 240, Enemy::BASIC, Enemy::LEFT );
					Enemy::Create( 240, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 21:
				{
					Enemy::Create( 160, Enemy::GIANT, Enemy::BOTTOM );
					Enemy::Create( 480, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::LEFT );
					Enemy::Create( 240, Enemy::EXPAND, Enemy::RIGHT );
					break;
				}
			case 22:
				{
					Enemy::Create( 128, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 224, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 320, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 416, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 512, Enemy::BASIC, Enemy::TOP );
					break;
				}
			case 23:
				{
					Enemy::Create( 320, Enemy::STAR, Enemy::TOP );
					Enemy::Create( 320, Enemy::STAR, Enemy::BOTTOM );
					Enemy::Create( 240, Enemy::BASIC, Enemy::LEFT );
					Enemy::Create( 240, Enemy::BASIC, Enemy::RIGHT );
					break;
				}
			case 24:
				{
					Enemy::Create( 120 * 1, Enemy::GIANT, Enemy::LEFT );
					//Enemy::Create( 80 * 3, Enemy::GIANT, Enemy::LEFT );
					Enemy::Create( 120 * 3, Enemy::GIANT, Enemy::RIGHT );
					Enemy::Create( 80 * 1, Enemy::GIANT, Enemy::BOTTOM );
					Enemy::Create( 80 * 3, Enemy::GIANT, Enemy::BOTTOM );
					Enemy::Create( 80 * 5, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 80 * 7, Enemy::GIANT, Enemy::TOP );
					/*Enemy::Create( 320, Enemy::GIANT, Enemy::RIGHT );
					Enemy::Create( 480, Enemy::GIANT, Enemy::TOP );
					Enemy::Create( 160, Enemy::GIANT, Enemy::BOTTOM );*/
					break;
				}
			case 0:
				{
					Enemy::Create( 240, Enemy::SPIDER, Enemy::LEFT );
					Enemy::Create( 240, Enemy::STAR, Enemy::RIGHT );
					Enemy::Create( 320, Enemy::GIANT, Enemy::BOTTOM );
					Enemy::Create( 160, Enemy::BASIC, Enemy::TOP );
					Enemy::Create( 480, Enemy::EXPAND, Enemy::TOP );
					break;
				}
			}
			// G𐶐
			/*new Enemy( 160, -32, Enemy::BASIC, DX_PI / 2 );
			//new Enemy( 320, -32, Enemy::BASIC, DX_PI / 2 );
			//new Enemy( 480, -32, Enemy::BASIC, DX_PI / 2 );
			//new Enemy( 160, 512, Enemy::EXPAND, DX_PI / 2 );
			//new Enemy( 320, 512, Enemy::EXPAND, DX_PI / 2 );
			//new Enemy( 480, 512, Enemy::EXPAND, DX_PI / 2 );
			new Enemy( 700, 240, Enemy::STAR, 0 );
			new Enemy( 320, -80, Enemy::GIANT, DX_PI / 2 );
			new Enemy( -48, 240, Enemy::SPIDER, 0 );*/
			_count++;
		}
		if( _count > LEVEL_DISP_COUNT ){
			if( Enemy::GetEnemyList().empty() ){
				_count = 0;
				_level++;
			}
		}
	}
	int Draw( void ){
		if( _count < LEVEL_DISP_COUNT ){
			std::ostringstream os;
			os << "LEVEL " << _level;
			int x = GetDrawStringWidth( os.str().c_str(), os.str().size() ) ;
			_count++;
			return DrawFormatString( 320 - x / 2, 240 - 8, GetColor( 255, 255, 255 ), os.str().c_str() );
		}
		return 0;
	}
	void Reset( void ){
		_level = 1;
		_count = 0;
	}
	// NW
	static double GetRankCoefficient( void ){
		return pow( 2.0 , 1.0 - 1.0 / ( 99.0 / 100.0 + _p->_level / 100.0 ) ) - 1;
	}
private:
	int _level;	// ݂̃x
	int _count;	// t[
	static const int LEVEL_DISP_COUNT = 120;
};

#endif