#include "Score.h"
#include <fstream>
#include <functional>
#include <algorithm>
#include <iostream>

void Score::Load( void ){
	std::ifstream ifs( "score.ini", std::ios::in );
	if( ifs ){
		// Jꍇ
		int score;
		for( int i = 0; i < 10; ++i ){
			ifs.ignore( 100, '=' );
			ifs >> score;
			AddScore( score );
		}
	}
	else{
		// JȂꍇ
		LoadDefault();
		Save();
	}
}
void Score::Save( void ){
	Sort();
	std::ofstream ofs( "score.ini" );

	auto it = _score.begin();

	ofs << "1st=" << ( *it ) << std::endl;
	++it;
	ofs << "2nd=" << ( *it ) << std::endl;
	++it;
	ofs << "3rd=" << ( *it ) << std::endl;
	++it;
	for( int i = 4; i <= 10; ++i ){
		ofs << i << "th=" << ( *it ) << std::endl;
	}
}
void Score::LoadDefault( void ){
	for( int i = 0; i < 10; ++i ){
		AddScore( 0 );
	}
}
void Score::AddScore( int score ){
	_score.push_front( score );
	Sort();
}
int Score::GetHighScore( void ){
	return ( *_score.begin() );
}
void Score::Sort( void ){
	_score.sort( std::greater< int >() );
}