#include "Shot.h"
#include "math.h"
#include "DxLib.h"

std::list<Shot*> Shot::_shotList;
const double Shot::VELOCITY( 24.0 );
int Shot::_img;

Shot::Shot( double x, double y, double th ) {
	_x = x;
	_y = y;
	_th = th;
	_exist = true;
	_shotList.push_back( this );
}
void Shot::Move( void ) {
	_x += VELOCITY * cos( _th );
	_y += VELOCITY * sin( _th );

	if ( _x < -100 || 740 < _x || _y < -100 || 580 < _y ) _exist = false;
}
void Shot::MoveAll( void ) {
	for( auto it = _shotList.begin(); it != _shotList.end(); ) {
		(*it)->Move();
		if ( ( *it )->_exist == FALSE ) {
			delete ( *it );
			it = _shotList.erase( it );
			continue;
		}
		++it;
	}
}
int Shot::Draw( void ) {
	int rv;
	SetDrawBlendMode( DX_BLENDMODE_ADD, 255 );
	rv = DrawRotaGraph( static_cast< int >( _x ), static_cast< int >( _y ),
		0.5, _th, _img, TRUE );
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
#ifdef _DEBUG
	DrawCircle( static_cast< int >( _x ), static_cast<int>( _y ),
		RADIUS, GetColor( 0, 255, 255 ), false );
#endif
	return rv;
}
void Shot::DrawAll( void ) {
	for( auto it = _shotList.begin(); it != _shotList.end(); ) {
		if ( ( *it )->_exist == FALSE ) {
			delete ( *it );
			it = _shotList.erase( it );
			continue;
		}
		( *it )->Draw();
		++it;
	}
}