#ifndef SHOT_H
#define SHOT_H

#include <list>
#include <map>
#include "DxLib.h"

class Shot {
public:
	Shot( double x, double y, double th );
	void Move( void );
	static void MoveAll( void );
	static void DrawAll( void );
	int Draw( void );
	static std::list<Shot*>& GetShotList( void ){
		return _shotList;
	}
	void GetPos( double& x, double& y ) {
		x = _x;
		y = _y;
	}
	void Hit( void ) {
		_exist = false;
	}
	static const int RADIUS = 8;
	bool IsExist( void ){
		return _exist;
	}
	static int LoadImg( void ){
		_img = LoadGraph( "img\\shot.png" );
		return 0;
	}
private:
	double _x;
	double _y;
	double _th;
	bool _exist;
	static int _img;

	static std::list<Shot*> _shotList;
	static const double VELOCITY;
public:
	double GetAngle( void ){
		return _th;
	}
};

#endif