#include "DxLib.h"
#include "Input.h"
#include "Player.h"
#include "Shot.h"
#include "Enemy.h"
#include "Collision.h"
#include "Level.h"
#include "Effect.h"
#include <sstream>
#include "Background.h"
#include "Item.h"
#include <fstream>
#include "Score.h"

Level* Level::_p;

int g_score;
int g_title;
int g_gameover;
int g_press_any_key;
int g_pause;

void AddScore( int num ){
	g_score += num;
}
int DrawScore( Score& score ){
	int rv;

	std::ostringstream highscore;
	std::ostringstream highscore_num;
	highscore_num.setf( std::ios::right );
	highscore_num.fill( '0' );
	highscore_num.width( 8 );
	highscore_num << ( g_score < score.GetHighScore() ? score.GetHighScore() : g_score );
	highscore << "HIGH SCORE: " << highscore_num.str();
	rv |= DrawFormatString( 0, 16, GetColor( 255, 255, 255 ), highscore.str().c_str() );
	
	std::ostringstream currentscore;
	std::ostringstream currentscore_num;
	currentscore_num.setf( std::ios::right );
	currentscore_num.fill( '0' );
	currentscore_num.width( 8 );
	currentscore_num << g_score;
	currentscore << "SCORE     : " << currentscore_num.str();
	rv |= DrawFormatString( 0, 32, GetColor( 255, 255, 255 ), currentscore.str().c_str() );

	return rv;
}
void Reset( Player& player, Level& level ){
	player.Reset();
	level.Reset();
	Enemy::EraseAll();
	Item::EraseAll();
	g_score = 0;
}
void LoadConfig( std::ifstream& ifs, int& bgm, int& se ){
	ifs.ignore( 100, '=' );
	ifs >> bgm;
	ifs.ignore( 100, '=' );
	ifs>> se;
	if( bgm < 0 || 100 < bgm ) bgm = 50;
	if( se < 0 || 100 < se ) se = 50;
}
void LoadDefaultConfig( int& bgm, int& se ){
	bgm = 50;
	se = 50;
}
void SaveDefaultConfig( void ){
	std::ofstream ofs( "config.ini" );
	ofs << "BGM_VOLUME=50" << std::endl;
	ofs << "SE_VOLUME=50" << std::endl;
}
int LoadSnd( void ){
	int seVolume = 255;
	int bgmVolume = 255;

	std::ifstream ifs( "config.ini", std::ios::in );
	if( ifs ){
		LoadConfig( ifs, bgmVolume, seVolume );
	}
	else{
		LoadDefaultConfig( bgmVolume, seVolume );
		SaveDefaultConfig();
	}
	seVolume = ( seVolume * 255 ) / 100;
	bgmVolume = ( bgmVolume * 255 ) / 100;

	Player::LoadSnd( seVolume );
	Enemy::LoadSnd( seVolume );
	
	static int bgm = LoadSoundMem( "bgm\\RIDING_BEAT.mp3" );
	ChangeVolumeSoundMem( bgmVolume, bgm );
	PlaySoundMem( bgm, DX_PLAYTYPE_LOOP );
	
	return 0;
}
int LoadImg( void ){
	Enemy::LoadImg();
	Shot::LoadImg();
	Effect::LoadImg();
	Item::LoadImg();
	Player::LoadModel();
	g_title = LoadGraph( "img\\title.png" );
	g_press_any_key = LoadGraph( "img\\press_any_key.png" );
	g_gameover = LoadGraph( "img\\gameover.png" );
	g_pause = LoadGraph( "img\\pause.png" );
	return 0;
}

// vO WinMain n܂܂
int Title( Background& background ){
	// L[܂ŃEFCg
	while( CheckHitKeyAll() != 0 ){
		ClearDrawScreen();
		background.Draw();
		DrawRotaGraph( 320, 160, 15.0, 0, g_title, TRUE );
		DrawRotaGraph( 320, 360, 2.0, 0, g_press_any_key, TRUE );
		ScreenFlip();
		if( ProcessMessage() == -1 ) break;
	}
	// L[܂ŃEFCg
	while( CheckHitKeyAll() == 0 ){
		ClearDrawScreen();
		background.Draw();
		DrawRotaGraph( 320, 160, 15.0, 0, g_title, TRUE );
		DrawRotaGraph( 320, 360, 2.0, 0, g_press_any_key, TRUE );
		ScreenFlip();
		if( ProcessMessage() == -1 ) break;
	}

	for( int i = 0; i < 100; ++i ){
		ClearDrawScreen();
		background.Draw();
		DrawRotaGraph( 320, 160, 15.0, 0, g_title, TRUE );
		if( i % 2 ){
			DrawRotaGraph( 320, 360, 2.0, 0, g_press_any_key, TRUE );
		}
		ScreenFlip();
		if( ProcessMessage() == -1 ) break;
	}

	return 0;
}
void Story( void ){
	// title
	int title = LoadGraph( "img\\title_sw.png" );

	// story fݒ
	int story = MV1LoadModel( "model\\story.mqo" );
	MV1SetScale( story, VGet( 5, 5, 5 ) );
	MV1SetRotationXYZ( story, VGet( ( DX_PI_F / 3 ), 0, 0 ) ) ;
	
	int flag = 0;

	// tHO̐ݒ
	SetFogEnable( TRUE );
	SetFogColor( 0, 0, 0 );

	for( int i = 0; -1300 * cos( DX_PI / 5 ) + i * cos( DX_PI / 5 ) < 1024; i++ ){
		ClearDrawScreen();
		
		// Xg[̈ړ
		MV1SetPosition( story, VGet( 320.0f, -1000 * sin( DX_PI_F / 5 ) + i * sin( DX_PI_F / 5 ), -800 * cos( DX_PI_F / 5 ) + i * cos( DX_PI_F / 5 ) ) );
		
		// `
		// ^Cg
		SetFogStartEnd( 5120.0f, 6148.0f );
		DrawBillboard3D( VGet( 320.0, 240.0, static_cast<float>( i ) * 12 ), 0.5, 0.5, 1024.0, 0.0, title, TRUE );

		// Xg[[
		SetFogStartEnd( 1024.0f, 1536.0f );
		MV1DrawModel( story );
		ScreenFlip();

		// Cӂ̃L[ꂽ甲
		if( flag == 0 ){
			if( CheckHitKeyAll() == 0 ){
				flag = 1;
			}
		}
		if( flag == 1 ){
			if( CheckHitKeyAll() ){
				// A[h
				DeleteGraph( title );
				MV1DeleteModel( story );

				// tHO
				SetFogEnable( FALSE );

				// uh[h߂
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
				
				return;
			}
		}
		if( ProcessMessage() == -1 ) return;
	}
	MV1DeleteModel( story );
	DeleteGraph( title );
}
int Pause( Input& input ){
	// L[܂ŃEFCg
	if( Input::GetButton( 0 ) == 1 ){
		// |[Yꂽ
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 128 );
		DrawBox( 0, 0, 640, 480, GetColor( 0, 0, 0 ), TRUE );
		SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
		DrawRotaGraph( 320, 240, 2.0, 0, g_pause, TRUE );
		ScreenFlip();

		// |[Yb܂ŃEFCg
		while( Input::GetButton( 0 ) > 0 ){
			WaitTimer( 10 );
			input.Update();
			if( ProcessMessage() == -1 ) break;
		}

		// |[Y܂ŃEFCg
		while( Input::GetButton( 0 ) == 0 ){
			WaitTimer( 10 );
			input.Update();
			if( ProcessMessage() == -1 ) break;
		}
	}
	return 0;
}
void Logo( void ){
	int img = LoadGraph( "img\\logo.png" );
	int flag = 0;

	// tF[hC
	for( int i = 0; i < 60; ++i ){
		ClearDrawScreen();
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, ( i * 255 ) / 60 );
		DrawRotaGraph( 320, 240, 1, 0, img, TRUE );
		ScreenFlip();
		if( flag == 0 ){
			if( CheckHitKeyAll() == 0 ){
				flag = 1;
			}
		}
		if( flag == 1 ){
			if( CheckHitKeyAll() ){
				DeleteGraph( img );
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
				return;
			}
		}
		if( ProcessMessage() == -1 ) return;
	}

	// EFCg
	for( int i = 0; i < 120; ++i ){
		WaitTimer( 16 );
		if( flag == 0 ){
			if( CheckHitKeyAll() == 0 ){
				flag = 1;
			}
		}
		if( flag == 1 ){
			if( CheckHitKeyAll() ){
				DeleteGraph( img );
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
				return;
			}
		}
		if( ProcessMessage() == -1 ) return;
	}

	// tF[hAEg
	for( int i = 0; i < 60; ++i ){
		ClearDrawScreen();
		SetDrawBlendMode( DX_BLENDMODE_ALPHA, 255 - ( i * 255 ) / 60 );
		DrawRotaGraph( 320, 240, 1, 0, img, TRUE );
		ScreenFlip();
		if( flag == 0 ){
			if( CheckHitKeyAll() == 0 ){
				flag = 1;
			}
		}
		if( flag == 1 ){
			if( CheckHitKeyAll() ){
				DeleteGraph( img );
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
				return;
			}
		}
		if( ProcessMessage() == -1 ) return;
	}

	// EFCg
	for( int i = 0; i < 60; ++i ){
		WaitTimer( 16 );
		if( flag == 0 ){
			if( CheckHitKeyAll() == 0 ){
				flag = 1;
			}
		}
		if( flag == 1 ){
			if( CheckHitKeyAll() ){
				DeleteGraph( img );
				SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
				return;
			}
		}
		if( ProcessMessage() == -1 ) return;
	}
	SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 );
}
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow ){
	ChangeWindowMode( TRUE );
	SetWindowText( "DGZ ver 1.00" );
	if( DxLib_Init() == -1 ){		// cwCu
		return -1 ;			// G[N璼ɏI
	}
	
	SetDrawScreen( DX_SCREEN_BACK );
	
	Logo();
	
	LoadImg();
	LoadSnd();

	Input input;
	Player player;
	Level level;
	Background background;
	Score score;
	score.Load();
	
	Story();
	Title( background );

	while( ProcessMessage() == 0 ){
		ClearDrawScreen();
		background.Draw();

		input.Update();

		level.Run();

		player.Move();
		Enemy::MoveAll();
		Shot::MoveAll();
		Item::MoveAll();

		Collision::EnemyShot();
		Collision::EnemyPlayer();
		Collision::ItemPlayer();

		if( player.GetLife() == -3 ){
			score.AddScore( g_score );
			score.Save();
			Title( background );
			Reset( player, level );
		}

		player.Draw();
		Enemy::DrawAll();
		Effect::DrawAll();
		Shot::DrawAll();
		Item::DrawAll();
		level.Draw();
		DrawScore( score );
		Pause( input );
		ScreenFlip();
	}

	DrawPixel( 320 , 240 , 0xffff ) ;	// _ł

	WaitKey() ;				// L[͑҂

	DxLib_End() ;				// cwCugp̏I

	return 0 ;				// \tg̏I 
}